<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_CuentaBancaria.xml */
/* Generado: 2021-03-04 14:43:30 */

/* Mantenimiento de los registros de la tabla MST_CuentaBancaria */
abstract class BaseMST_CuentaBancariaDP extends MST_CuentaBancariaBV
{
    /* Constructor ( Establece los valores desde un objeto MST_CuentaBancariaBN ) */
    public function __construct( MST_CuentaBancariaBN $o_MST_CuentaBancariaBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_CuentaBancariaBN ) )
        {
            $this->setByBN( $o_MST_CuentaBancariaBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_CuentaBancariaBN */
    public function setByBN( MST_CuentaBancariaBN $o_MST_CuentaBancariaBN )
    {
        if ( !is_null( $o_MST_CuentaBancariaBN->getIdCuenta() ) )
        {
            $this->setIdCuenta( $o_MST_CuentaBancariaBN->getIdCuenta() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getIdBanco() ) )
        {
            $this->setIdBanco( $o_MST_CuentaBancariaBN->getIdBanco() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getNumeroCuenta() ) )
        {
            $this->setNumeroCuenta( $o_MST_CuentaBancariaBN->getNumeroCuenta() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getNumeroCuentaCCI() ) )
        {
            $this->setNumeroCuentaCCI( $o_MST_CuentaBancariaBN->getNumeroCuentaCCI() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getIdMoneda() ) )
        {
            $this->setIdMoneda( $o_MST_CuentaBancariaBN->getIdMoneda() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getNombreMoneda() ) )
        {
            $this->setNombreMoneda( $o_MST_CuentaBancariaBN->getNombreMoneda() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getFlagDetraccion() ) )
        {
            $this->setFlagDetraccion( $o_MST_CuentaBancariaBN->getFlagDetraccion() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getIdUbigeo() ) )
        {
            $this->setIdUbigeo( $o_MST_CuentaBancariaBN->getIdUbigeo() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getNombreSucursal() ) )
        {
            $this->setNombreSucursal( $o_MST_CuentaBancariaBN->getNombreSucursal() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getDescripcionCuenta() ) )
        {
            $this->setDescripcionCuenta( $o_MST_CuentaBancariaBN->getDescripcionCuenta() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getNumeroCuentaCorto() ) )
        {
            $this->setNumeroCuentaCorto( $o_MST_CuentaBancariaBN->getNumeroCuentaCorto() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getCodigoSunat() ) )
        {
            $this->setCodigoSunat( $o_MST_CuentaBancariaBN->getCodigoSunat() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getFlagMostrarCuenta() ) )
        {
            $this->setFlagMostrarCuenta( $o_MST_CuentaBancariaBN->getFlagMostrarCuenta() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getEstado() ) )
        {
            $this->setEstado( $o_MST_CuentaBancariaBN->getEstado() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_CuentaBancariaBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_CuentaBancariaBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_CuentaBancariaBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MST_CuentaBancariaBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MST_CuentaBancariaBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_CuentaBancariaFN = new MST_CuentaBancariaFN();
        $o_MST_CuentaBancariaBN = $o_MST_CuentaBancariaFN->selectByPk( $this->getIdCuenta() );
        if ( is_null( $o_MST_CuentaBancariaBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_CuentaBancaria ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCuenta() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCuenta";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCuenta()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdBanco() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdBanco";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdBanco()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroCuenta() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NumeroCuenta";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNumeroCuenta()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroCuentaCCI() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NumeroCuentaCCI";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNumeroCuentaCCI()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdMoneda() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdMoneda";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdMoneda()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreMoneda() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NombreMoneda";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombreMoneda()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagDetraccion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FlagDetraccion";
                $s_SQLQuery2 .= $s_Separator."".$this->getFlagDetraccion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUbigeo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUbigeo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdUbigeo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NombreSucursal";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombreSucursal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcionCuenta() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DescripcionCuenta";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcionCuenta()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroCuentaCorto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NumeroCuentaCorto";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNumeroCuentaCorto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoSunat() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CodigoSunat";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCodigoSunat()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagMostrarCuenta() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FlagMostrarCuenta";
                $s_SQLQuery2 .= $s_Separator."".$this->getFlagMostrarCuenta()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_CuentaBancaria SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdBanco() ) )
            {
                $s_SQLQuery .= $s_Separator."IdBanco = ".$this->getIdBanco()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroCuenta() ) )
            {
                $s_SQLQuery .= $s_Separator."NumeroCuenta = '".$this->getNumeroCuenta()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroCuentaCCI() ) )
            {
                $s_SQLQuery .= $s_Separator."NumeroCuentaCCI = '".$this->getNumeroCuentaCCI()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdMoneda() ) )
            {
                $s_SQLQuery .= $s_Separator."IdMoneda = '".$this->getIdMoneda()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreMoneda() ) )
            {
                $s_SQLQuery .= $s_Separator."NombreMoneda = '".$this->getNombreMoneda()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagDetraccion() ) )
            {
                $s_SQLQuery .= $s_Separator."FlagDetraccion = ".$this->getFlagDetraccion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUbigeo() ) )
            {
                $s_SQLQuery .= $s_Separator."IdUbigeo = '".$this->getIdUbigeo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."NombreSucursal = '".$this->getNombreSucursal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcionCuenta() ) )
            {
                $s_SQLQuery .= $s_Separator."DescripcionCuenta = '".$this->getDescripcionCuenta()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroCuentaCorto() ) )
            {
                $s_SQLQuery .= $s_Separator."NumeroCuentaCorto = '".$this->getNumeroCuentaCorto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoSunat() ) )
            {
                $s_SQLQuery .= $s_Separator."CodigoSunat = '".$this->getCodigoSunat()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagMostrarCuenta() ) )
            {
                $s_SQLQuery .= $s_Separator."FlagMostrarCuenta = ".$this->getFlagMostrarCuenta()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdCuenta = ".$this->getIdCuenta().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_CuentaBancaria WHERE  IdCuenta = ".$this->getIdCuenta().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>